use lib './lib';
use lib '.';
use DSL::English::DataQueryWorkflows;

#-----------------------------------------------------------
my $pCOMMAND = DSL::English::DataQueryWorkflows::Grammar;

sub dq-subparse(Str:D $command, Str:D :$rule = 'TOP') {
    $pCOMMAND.subparse($command, :$rule);
}

sub dq-parse(Str:D $command, Str:D :$rule = 'TOP') {
    $pCOMMAND.parse($command, :$rule);
}

sub dq-interpret(Str:D $command,
                 Str:D:$rule = 'TOP',
                 :$actions = DSL::English::DataQueryWorkflows::Actions::Raku::Reshapers.new) {
    $pCOMMAND.parse($command, :$rule, :$actions).made;
}

#--
say "=" x 60;

#say dq-parse("summarize with Norm = `sqrt(sum(Square))`", rule => 'summarize-command');
#say dq-parse("summarize data", rule => 'statistics-command');
#say dq-interpret(
#        @testCommands[0],
#        rule => 'workflow-commands-list',
#        actions => DSL::English::DataQueryWorkflows::Actions::R::base.new);

#say dq-parse('load the data table dfTitanic');

#say dq-parse('rename id as VAR1, species as DATE, noun as Project');
#my $testCommand = 'to wide form for id columns Set and AutomaticKey variable column Variable and value column Value';
#my $testCommand = '
#transform with bmi = `mass/height^2*10000`;
#transform with bmi = `$_<mass>/$_<height>^2*10000` and homeworld = `$_<homeworld>.uc`;';

#my $testCommand = "use dfRand; show dimensions; take first 100; show dimensions; drop \"C\"; group by \"A\" and \"B\"; counts; take pipeline value";
#my $testCommand = "use dfRand; show dimensions; take first 100; show dimensions; drop \"C\"; group by \"A\"; counts; take pipeline value";
#my $testCommand = "use @dfSample; anti-join with @dsSampleNew over p_start and p_end";
my $testCommand = "use dsOrders2022; rename Item = shipper_order_id;";

#============================================================
# Star Wars complicated workflow
#============================================================
#my $testCommand = '
#use data frame dfStarwars;
#keep the columns name, homeworld, mass & height;
#replace missing in mass and height with 0;
#replace missing with 0;
#transform with bmi = `mass/height^2*10000`;
#transform with bmi = ${mass/height^2*10000};
#filter rows by bmi >= 30 & height < 200;
#arrange by the variables mass & height descending';

#============================================================
# Anscombe's quartet
#============================================================

#my $testCommand = q:to/END/;
#        use dfAnscombe;
#        convert to long form;
#        separate the data column "Variable" into "Variable" and "Set" with pattern "";
#        to wide form for id columns Set and "Unnamed: 0" variable column Variable and value column Value
#        END

#my $testCommand = 'convert to long form with variable columns `!starts_with("Index")`';
#my $testCommand = 'convert to long form with variable columns "Index1", "Index2"';
#my $testCommand = 'convert to long form with variable columns "Index1", "Index2" with variable name "Var" with value name "Val"';
#my $testCommand = 'convert to long form with variable columns `!starts_with("Index")`, variable name "Variable", value name "Value"';
#my $testCommand = '
#convert to long form with variable columns "Index1", "Index2" with variable name "Var" with value name `Val`;
#to wide form for id columns "Set" and "Index" variable column "Variable" and value column "Value"
#';
#my $testCommand = 'separate the data column "Variable" into "Variable" and "Set" with separator ""';

#============================================================
# Parsing
#============================================================
# say dq-parse($testCommand);

say dq-interpret(
        $testCommand,
        rule => 'workflow-commands-list',
        actions => DSL::English::DataQueryWorkflows::Actions::R::tidyverse.new);