use lib './lib';
use lib '.';
use DSL::English::DataQueryWorkflows;

#-----------------------------------------------------------
my $pCOMMAND = DSL::English::DataQueryWorkflows::Grammar;

sub dq-subparse(Str:D $command, Str:D :$rule = 'TOP') {
    $pCOMMAND.subparse($command, :$rule);
}

sub dq-parse(Str:D $command, Str:D :$rule = 'TOP') {
    $pCOMMAND.parse($command, :$rule);
}

sub dq-interpret(Str:D $command,
                 Str:D:$rule = 'TOP',
                 :$actions = DSL::English::DataQueryWorkflows::Actions::R::tidyverse.new) {
    $pCOMMAND.parse($command, :$rule, :$actions).made;
}

#--
say "=" x 60;

# <summarize-at>
#my $testCommand = 'summarize the variables mass and height with mean and median';
#my $testCommand = 'summarize using mass : `["min", "mean"]` and height : `["min", "max"]`';
#my $testCommand = 'summarize using mass : `{Min[#mass], Max[#mass]}` and height : `{Min[#height], Max[#height]}`';

# <summarize-all>
my $testCommand = 'summarize all with &mean and &median';

# <pivot-wider>
#my $testCommand = 'to wide form for id columns Set and AutomaticKey variable column Variable and value column Value';

# say dq-parse($testCommand);

say dq-interpret(
        $testCommand,
        rule => 'workflow-commands-list',
        actions => DSL::English::DataQueryWorkflows::Actions::Raku::Reshapers.new);